/**
 * This class contains functions specific to the Save throbber.
 * @param {GenericTab} generic An optional GenericThrobber to prevent having to create multiple copies.
 */
function SaveThrobber(generic) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var gen = generic ? generic : new GenericThrobber();
    var id = "saving";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Shows this throbber.
     */
    this.show = function () {
        gen.show(id);
    };

    /**
     * Shows and then hides this throbber.
     */
    this.showAndHide = function () {
        gen.show(id);
        setTimeout(function () {
            that.hide();
        }, 1200);
    };

    /**
     * Hides this throbber.
     */
    this.hide = function () {
        gen.hide(id);
    };
}
