/**
 * Controller for the Breeding Farm scene.
 * @param {string} sceneId The id of the scene.
 */
function BreedingFarmController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;

    var autoSaveId = "autoSave";
    var continueId = "continue";


    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    function ChoiceController(key) {
        this.continue = function () {
            global.kobold.history.setKey(id, key, true);
        };
        this.continued = function () {
            return global.kobold.history.has(id, key);
        };
        this.set = function (choice) {
            global.kobold.history.setKey(id, key, choice);
        };
        this.get = function () {
            return global.kobold.history.getKey(id, key);
        };
        this.has = function () {
            return global.kobold.history.has(id, key);
        };
        this.unset = function () {
            global.kobold.history.unsetKey(id, key);
        };
    }

    function EagerController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(10, "Caught by Cassidy");
                global.kobold.status.exertion.increase(5, "Loins fondled");
            });
            return global.ui.change.buildNotification([
                new Change("Betrayed", "Sanity", -5),
                new Change("Trapped", "Sanity", -5),
                new Change("Loins fondled", "Sexual exhaustion", +5, true)
            ]);
        };
    }

    function TableController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(15, "Sickened by kobold breeding");
            });
            return global.ui.change.buildNotification([
                new Change("Terrified", "Sanity", -10),
                new Change("Sickened", "Sanity", -5)
            ]);
        };
    }

    function InjectionController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.physical.decrease(5, "Injection");
                global.kobold.status.mental.decrease(5, "Injection");
            });
            return global.ui.change.buildNotification([
                new Change("Injection", "Health", -5),
                new Change("Injection", "Sanity", -5)
            ]);
        };
    }

    function TransformationController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(10, "Transformation");
                if (global.kobold.body.dick) {
                    global.kobold.body.growDick(global.kobold.body.dick - 1);
                } else {
                    global.kobold.body.growBreasts(global.kobold.body.breasts + 1);
                }
            });
            return global.ui.change.buildNotification([
                new Change("Transformation", "Sanity", -10)
            ]);
        };
    }

    function BarnResistController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(15, "Resisted transformation");
            });
            return global.ui.change.buildNotification([
                new Change("Resisted transformation", "Sanity", +15)
            ]);
        };
    }

    function BarnTableRapeController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                if (global.kobold.body.dick) {
                    global.kobold.body.cockslitVirgin = false;
                } else {
                    global.kobold.body.vaginalVirgin = false;
                }
                global.kobold.status.physical.decrease(5, "Rough sex");
                global.kobold.status.mental.decrease(20, "Raped");
                global.kobold.status.exertion.increase(20, "Raped");
                global.kobold.history.shared.cassidy.tableraped = true;
            });
            return global.ui.change.buildNotification([
                new Change("Rough sex", "Health", -5),
                new Change("Raped", "Sanity", -20),
                new Change("Raped", "Sexual exhaustion", +20, true)
            ]);
        };
    }

    function BarnEscapeController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(10, "Escaped from the barn");
                global.kobold.status.stamina.decrease(25, "Escaped from the barn");
                global.kobold.stats.decreaseStat(StatsEnum.STRENGTH, 1);
            });
            return global.ui.change.buildNotification([
                new Change("Escaped", "Sanity", +10),
                new Change("Escaped", "Stamina", -25),
                new Change("Lasting effects", "Strength", -1),
            ]);
        };
    }

    function UnawareController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(10, "Escaped from table");
            });
            return global.ui.change.buildNotification([
                new Change("Escaped table", "Sanity", +10)
            ]);
        };
    }

    function UnawareRunController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.stamina.decrease(25, "Ran from Cassidy");
            });
            return global.ui.change.buildNotification([
                new Change("Ran away", "Stamina", -25)
            ]);
        };
    }

    function UnawareAttackController(key) {
        ChoiceController.call(this, key);

        this.change = function (weapon) {
            var changeId = key + "Change";
            if (weapon.stab()) {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.status.mental.decrease(10, "Killed Cassidy");
                });
                return global.ui.change.buildNotification([
                    new Change("Revenge", "Sanity", +10),
                    new Change("Murder", "Sanity", -20)
                ]);
            } else {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.status.mental.increase(10, "Got revenge");
                });
                return global.ui.change.buildNotification([
                    new Change("Revenge", "Sanity", +10)
                ]);
            }
        };
    }

    function UnawareFreeController(key) {
        this.change = function (weapon) {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(30, "Kobold saviour");
            });
            return global.ui.change.buildNotification([
                new Change("Unsung hero", "Sanity", +30)
            ]);
        };
    }

    function UnawareLootController(key) {
        ChoiceController.call(this, key);

        this.change = function () {
            var changeId = key + "Change";
            if (global.kobold.history.shared.cassidy.dead) {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.inventory.bag.addMisc(new CassidyHouseKey());
                    global.kobold.inventory.bag.addConsumable(new FemPlus());
                });
                return global.ui.change.buildNotification([
                    new Change("Loot", global.kobold.inventory.createItemWithTooltip(new CassidyHouseKey(), true), +1),
                    new Change("Loot", global.kobold.inventory.createItemWithTooltip(new FemPlus(), true), +1)
                ]);
            } else {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.inventory.bag.addConsumable(new FemPlus());
                });
                return global.ui.change.buildNotification([
                    new Change("Loot", global.kobold.inventory.createItemWithTooltip(new FemPlus()), +1)
                ]);
            }
        };
    }
    
    function BarnForceController(key) {
        ChoiceController.call(this, key);
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.physical.decrease(5, "Light scratches");
                global.kobold.status.stamina.decrease(10, "Bear-hugging a vixen");
            });
            return global.ui.change.buildNotification([
                new Change("Scratched by spurs", "Health", -5),
                new Change("Physical exertion", "Stamina", -10)
            ]);
        };
    }

    function BarnForceFreeController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(30, "Kobold saviour");
            });
            return global.ui.change.buildNotification([
                new Change("Unsung hero", "Sanity", +30)
            ]);
        };
    }

    function BarnForceFuckController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(20, "Righteous retribution");
                global.kobold.inventory.bag.addConsumable(new FemPlus());
            });
            return global.ui.change.buildNotification([
                new Change("Righteous retribution", "Sanity", +20),
                new Change("Loot", new FemPlus().name(true), +1)
            ]);
        };
    }

    function MiscController() {
        this.gold = function () {
            var goldId = "gold";
            global.kobold.history.setIfNotSet(id, goldId, global.kobold.inventory.coins);
            return global.kobold.history.getKey(id, goldId);
        };

        this.strip = function () {
            var stripId = "strip";
            global.kobold.history.doIfNotSet(id, stripId, true, function () {
                global.kobold.inventory.equipment.stripNaked();
            });
        };

        this.pants = function () {
            var pantsId = "pants";
            global.kobold.history.setIfNotSet(id, pantsId, global.kobold.inventory.equipment.pants);
            return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, pantsId));
        };

        this.wearPants = function (bottom) {
            var pantsId = "wearPants";
            global.kobold.history.doIfNotSet(id, pantsId, true, function () {
                global.kobold.inventory.equipment.wear(bottom);
            });
        };

        this.removePants = function () {
            var pantsId = "removePants";
            global.kobold.history.doIfNotSet(id, pantsId, true, function () {
                global.kobold.inventory.equipment.strip(SlotEnum.PANTS);
            });
        };

        this.bra = function () {
            var braId = "bra";
            global.kobold.history.setIfNotSet(id, braId, global.kobold.inventory.equipment.bra);
            return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, braId));
        };

        this.removeBra = function () {
            var braId = "removeBra";
            global.kobold.history.doIfNotSet(id, braId, true, function () {
                global.kobold.inventory.equipment.strip(SlotEnum.BRA);
            });
        };

        this.shirt = function () {
            var shirtId = "shirt";
            global.kobold.history.setIfNotSet(id, shirtId, global.kobold.inventory.equipment.shirt);
            return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, shirtId));
        };

        this.wearShirt = function (top) {
            var shirtId = "wearShirt";
            global.kobold.history.doIfNotSet(id, shirtId, true, function () {
                global.kobold.inventory.equipment.wear(top);
            });
        };

        this.removeShirt = function () {
            var shirtId = "removeShirt";
            global.kobold.history.doIfNotSet(id, shirtId, true, function () {
                global.kobold.inventory.equipment.strip(SlotEnum.SHIRT);
            });
        };

        this.underwear = function () {
            var underwearId = "underwear";
            global.kobold.history.setIfNotSet(id, underwearId, global.kobold.inventory.equipment.underwear);
            return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, underwearId));
        };

        this.wearUnderwear = function (undies) {
            var underwearId = "wearUnderwear";
            global.kobold.history.doIfNotSet(id, underwearId, true, function () {
                global.kobold.inventory.equipment.wear(undies);
            });
        };

        this.removeUnderwear = function () {
            var underwearId = "removeUnderwear";
            global.kobold.history.doIfNotSet(id, underwearId, true, function () {
                global.kobold.inventory.equipment.strip(SlotEnum.UNDERWEAR);
            });
        };

        this.helmet = function () {
            var helmetId = "helmet";
            global.kobold.history.setIfNotSet(id, helmetId, global.kobold.inventory.equipment.helmet);
            return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, helmetId));
        };

        this.shoes = function () {
            var shoesId = "shoes";
            global.kobold.history.setIfNotSet(id, shoesId, global.kobold.inventory.equipment.shoes);
            return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, shoesId));
        };

        this.weapon = function () {
            var weaponId = "weapon";
            global.kobold.history.setIfNotSet(id, weaponId, global.kobold.inventory.equipment.weapon);
            return global.kobold.inventory.equipment.buildGearFromHistory(global.kobold.history.getKey(id, weaponId));
        };

        this.gender = function () {
            var genderId = "gender";
            global.kobold.history.setIfNotSet(id, genderId, global.kobold.body.gender);
            return global.kobold.history.getKey(id, genderId);
        };

        this.baseGender = function () {
            var baseGenderId = "baseGender";
            global.kobold.history.setIfNotSet(id, baseGenderId, global.kobold.body.getBaseGender());
            return global.kobold.history.getKey(id, baseGenderId);
        };

        this.dick = function () {
            var dickId = "dick";
            global.kobold.history.setIfNotSet(id, dickId, global.kobold.body.dick);
            return global.kobold.history.getKey(id, dickId);
        };

        this.dickVirgin = function () {
            var dickVirginId = "dickVirgin";
            global.kobold.history.setIfNotSet(id, dickVirginId, global.kobold.body.dickVirgin);
            return global.kobold.history.getKey(id, dickVirginId);
        };

        this.cockslitVirgin = function () {
            var cockslitVirginId = "cockslitVirgin";
            global.kobold.history.setIfNotSet(id, cockslitVirginId, global.kobold.body.cockslitVirgin);
            return global.kobold.history.getKey(id, cockslitVirginId);
        };

        this.cunt = function () {
            var cuntId = "cunt";
            global.kobold.history.setIfNotSet(id, cuntId, global.kobold.body.cunt);
            return global.kobold.history.getKey(id, cuntId);
        };

        this.cuntVirgin = function () {
            var cuntVirginId = "cuntVirgin";
            global.kobold.history.setIfNotSet(id, cuntVirginId, global.kobold.body.vaginalVirgin);
            return global.kobold.history.getKey(id, cuntVirginId);
        };

        this.analVirgin = function () {
            var analVirginId = "analVirgin";
            global.kobold.history.setIfNotSet(id, analVirginId, global.kobold.body.analVirgin);
            return global.kobold.history.getKey(id, analVirginId);
        };

        this.boobs = function () {
            var boobsId = "boobs";
            global.kobold.history.setIfNotSet(id, boobsId, global.kobold.body.breasts);
            return global.kobold.history.getKey(id, boobsId);
        };

        this.lactating = function () {
            var lactatingId = "lactating";
            global.kobold.history.setIfNotSet(id, lactatingId, global.kobold.body.lactating);
            return global.kobold.history.getKey(id, lactatingId);
        };

        this.name = function () {
            var nameId = "name";
            global.kobold.history.setIfNotSet(id, nameId, global.kobold.name);
            return global.kobold.history.getKey(id, nameId);
        };

        this.health = function () {
            var healthId = "health";
            global.kobold.history.setIfNotSet(id, healthId, global.kobold.status.physical.get());
            return global.kobold.history.getKey(id, healthId);
        };

        this.sanity = function () {
            var sanityId = "sanity";
            global.kobold.history.setIfNotSet(id, sanityId, global.kobold.status.mental.get());
            return global.kobold.history.getKey(id, sanityId);
        };

        this.stamina = function () {
            var staminaId = "stamina";
            global.kobold.history.setIfNotSet(id, staminaId, global.kobold.status.stamina.get());
            return global.kobold.history.getKey(id, staminaId);
        };

        this.exertion = function () {
            var exertionId = "exertion";
            global.kobold.history.setIfNotSet(id, exertionId, global.kobold.status.exertion.get());
            return global.kobold.history.getKey(id, exertionId);
        };

        this.agility = function () {
            var agilityId = "agility";
            global.kobold.history.setIfNotSet(id, agilityId, global.kobold.stats.get(StatsEnum.AGILITY));
            return global.kobold.history.getKey(id, agilityId);
        };

        this.charisma = function () {
            var charismaId = "charisma";
            global.kobold.history.setIfNotSet(id, charismaId, global.kobold.stats.get(StatsEnum.CHARISMA));
            return global.kobold.history.getKey(id, charismaId);
        };

        this.endurance = function () {
            var enduranceId = "endurance";
            global.kobold.history.setIfNotSet(id, enduranceId, global.kobold.stats.get(StatsEnum.ENDURANCE));
            return global.kobold.history.getKey(id, enduranceId);
        };

        this.intelligence = function () {
            var intelligenceId = "intelligence";
            global.kobold.history.setIfNotSet(id, intelligenceId, global.kobold.stats.get(StatsEnum.INTELLIGENCE));
            return global.kobold.history.getKey(id, intelligenceId);
        };

        this.luck = function () {
            var luckId = "luck";
            global.kobold.history.setIfNotSet(id, luckId, global.kobold.stats.get(StatsEnum.LUCK));
            return global.kobold.history.getKey(id, luckId);
        };

        this.strength = function () {
            var strengthId = "strength";
            global.kobold.history.setIfNotSet(id, strengthId, global.kobold.stats.get(StatsEnum.STRENGTH));
            return global.kobold.history.getKey(id, strengthId);
        };
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.misc = new MiscController("");
    this.arrival = new ChoiceController("arrival");
    this.barn = new ChoiceController("barn");
    this.eager = new EagerController("eager");
    this.table = new TableController("table");
    this.injection = new InjectionController("injection");
    this.transformation = new TransformationController("transformation");
    this.barnResist = new BarnResistController("barnResist");
    this.tableRape = new BarnTableRapeController("barnTableRape");
    this.tiedUp = new ChoiceController("barnTied");
    this.barnEscape = new BarnEscapeController("barnEscape");
    this.unaware = new UnawareController("unaware");
    this.unawareRun = new UnawareRunController("unawareRun");
    this.unawareAttack = new UnawareAttackController("unawareAttack");
    this.unawareLoot = new UnawareLootController("unawareLoot");
    this.unawareFree = new UnawareFreeController("unawareFree");
    this.barnForce = new BarnForceController("barnForce");
    this.barnForceFree = new BarnForceFreeController("barnForceFree");
    this.barnForceFuck = new BarnForceFuckController("barnForceFuck");

    this.tea = new ChoiceController("tea");
    this.notbarn = new ChoiceController("notbarn");
    this.postnotbarn = new ChoiceController("postnotbarn");
    this.postnotbarnsex = new ChoiceController("postnotbarnsex");
    this.notbarnloot = new ChoiceController("notbarnloot");
    this.postnotbarnloot = new ChoiceController("postnotbarnloot");

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    this.teaDeclineChange = function () {
        var changeId = "teaDeclineChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.mental.decrease(10, "Self-doubt");
        });
        return global.ui.change.buildNotification([
            new Change("Self-doubt", "Sanity", -10)
        ]);
    };
    
    this.teaDisagreeChange = function () {
        var changeId = "teaDisagreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.physical.increase(5, "Drank tea");
        });
        return global.ui.change.buildNotification([
            new Change("Tea", "Health", 5)
        ]);
    };

    this.teaDisagreeContinueChange = function () {
        var changeId = "teaDisagreeContinueChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.mental.decrease(20, "Kobolds are pets");
        });
        return global.ui.change.buildNotification([
            new Change("Realization", "Sanity", -20)
        ]);
    };
    
    this.teaAgreeChange = function () {
        var changeId = "teaAgreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.history.shared.cassidy.agree = true;
            global.kobold.status.physical.increase(10, "Tea and biscuits");
            global.kobold.inventory.bag.addConsumable(new TeaBiscuit(), 5);
        });
        return global.ui.change.buildNotification([
            new Change("Tea and biscuits", "Health", 10),
            new Change("Parting gift", new TeaBiscuit().name(true), 5)
        ]);
    };
    
    this.teaAgreeContinueChange = function () {
        var changeId = "teaAgreeContinueChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.mental.increase(10, "Made a friend");
        });
        return global.ui.change.buildNotification([
            new Change("Made a friend", "Sanity", 10)
        ]);
    };
    
    this.notbarnDownstairsLootChange = function () {
        var changeId = "notbarnDownstairsLootChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.inventory.bag.addMisc(new Silverware());
        });
        return global.ui.change.buildNotification([
            new Change("Stolen goods", new Silverware().name(true), +1)
        ]);
    };
    
    this.notbarnUpstairsLootChange = function () {
        var changeId = "notbarnUpstairsLootChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.physical.decrease(5, "Fell down");
            global.kobold.inventory.coins += 43;
        });
        return global.ui.change.buildNotification([
            new Change("Tripped", "Health", -5),
            new Change("Loot", "Coins", +43)
        ]);
    };
    
    this.notbarnLootContinueChange = function () {
        var changeId = "notbarnLootContinueChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.stamina.decrease(10, "Post-break-in escape");
        });
        return global.ui.change.buildNotification([
            new Change("Running away", "Stamina", -10)
        ]);
    };
    
    this.notbarnDisagreeChange = function () {
        var changeId = "notbarnDisagreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.history.shared.cassidy.sex = true;
            global.kobold.status.physical.decrease(5, "Thrown to the floor");
        });
        return global.ui.change.buildNotification([
            new Change("Fell down", "Health", -5)
        ]);
    };
    
    this.notbarnDisagreeSexChange = function () {
        var changeId = "notbarnDisagreeSexChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.oralVirgin = false;
            global.kobold.status.exertion.increase(10, "Vixen facesitting");
        });
        return global.ui.change.buildNotification([
            new Change("Intense oral", "Sexual exhaustion", +10)
        ]);
    };
    
    this.notbarnDisagreeContinueChange = function () {
        var changeId = "notbarnDisagreeContinueChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.sanity.decrease(15, "Forced femdom");
        });
        return global.ui.change.buildNotification([
            new Change("Used for pleasure", "Sanity", -15)
        ]);
    };
    
    this.notbarnAgreeChange = function () {
        var changeId = "notbarnAgreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.history.shared.cassidy.agree = true;
            global.kobold.history.shared.cassidy.sex = true;
        });
        return "";
    };
    
    function notbarnAgreeSmallDickSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.dickVirgin = false;
            global.kobold.status.mental.decrease(15, "Inadequate lover");
            global.kobold.status.stamina.decrease(10, "Fucked Cassidy");
            global.kobold.status.exertion.increase(15, "Fucked Cassidy");
            global.kobold.inventory.bag.addConsumable(new mPlus());
        });
        return global.ui.change.buildNotification([
            new Change("Failed to please", "Sanity", -15),
            new Change("One-sided sex", "Stamina", -10),
            new Change("One-sided sex", "Sexual exhaustion", +15, true),
            new Change("Degrading gift", new mPlus().name(true), +1)
        ]);
    };
    
    function notbarnAgreeMediumDickSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.dickVirgin = false;
            global.kobold.status.mental.increase(10, "Pleased the bitch");
            global.kobold.status.stamina.decrease(15, "Fucked Cassidy");
            global.kobold.status.exertion.increase(20, "Fucked Cassidy");
        });
        return global.ui.change.buildNotification([
            new Change("Pleased Cassidy", "Sanity", +10),
            new Change("Pleasant fuck", "Stamina", -15),
            new Change("Pleasant fuck", "Sexual exhaustion", +20, true)
        ]);
    };
    
    function notbarnAgreeBigDickSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.dickVirgin = false;
            global.kobold.status.mental.increase(15, "Broke the bitch");
            global.kobold.status.stamina.decrease(20, "Demolished Cassidy");
            global.kobold.status.exertion.increase(25, "Demolished Cassidy");
        });
        return global.ui.change.buildNotification([
            new Change("Broke the bitch", "Sanity", +15, ),
            new Change("Intense sex", "Stamina", -20),
            new Change("Intense sex", "Sexual exhaustion", +25, true)
        ]);
    };
    
    function notbarnAgreeFemaleSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.exertion.increase(20, "Eaten out");
        });
        return global.ui.change.buildNotification([
            new Change("Eaten out", "Sexual exhaustion", +20, true)
        ]);
    };
    
    this.notbarnAgreeSexChange = function (dick) {
        var changeId = "notbarnAgreeSexChange";
        if(!dick) {
            return notbarnAgreeFemaleSexChange(changeId);
        }
        if(dick < SizeEnum.AVERAGE) {
            return notbarnAgreeSmallDickSexChange(changeId);
        }
        if(dick < SizeEnum.LARGER) {
            return notbarnAgreeMediumDickSexChange(changeId);
        }
        return notbarnAgreeBigDickSexChange(changeId);
    };

    /*
     * Autosaves the game if necessary.
     */
    this.autosave = function () {
        global.kobold.history.doIfNotSet(id, autoSaveId, true, function () {
            global.saveManager.autoSave();
        });
    };

    /**
     * Signals the scene has been continued.
     */
    this.continue = function () {
        global.kobold.history.setKey(id, continueId, true);
    };

    /**
     * Returns whether or not the scene has continued.
     * @returns {boolean} True if the scene has continued, false otherwise.
     */
    this.continued = function () {
        return global.kobold.history.has(id, continueId);
    };
}

