/**
 * Barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function BarnEscape(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = "barnEscapeContinueButton";

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var pants = ctrl.misc.pants();
        var underwear = ctrl.misc.underwear();
        var shirt = ctrl.misc.shirt();
        var bra = ctrl.misc.bra();
        var weapon = ctrl.misc.weapon();
        var gear = pants || underwear || shirt || bra || weapon;
        var toReturn = `[p]
                            You lay there, motionless, a million thoughts racing through your mind while you listen to the vixen's muffled footsteps fading.
                            You hear a door opening, closing again, and then locking.
                            With Cassidy having left the barn, it feels as though a great burden is lifted off your shoulders.
                            You let out a loud, deeply depressed sigh.
                            For a few more minutes, you audibly cry, no longer needing to hold yourself back to save face.
                            You slowly rock back and forth, wishing you were [i]anywhere but here[/i].
                        [/p]
                        [p]
                            During your soothing motion, you notice something.
                            The rope around your wrists is kind of...[i]slack[/i].
                            In fact, you aren't properly tied together at all.
                            The bitch must have been relying on the paralyzing agent, or perhaps on your weariness.
                            While you [b]are[/b] tired, oh so [b]very[/b] tired, you aren't about to pass out.
                            Not yet, anyway.
                        [/p]
                        [p]
                            The bindings holding your wrists together were made poorly enough for you to be able to reach the rope itself with your fingers.
                            Using your sharp claws, you manage to free yourself in a matter of minutes, the thick rope somewhat tough to cut through.
                            Before you free your legs, you first wipe your tears and somewhat tidy your loins, wiping several palmfuls of sticky spunk off onto the ground.
                            After removing your bonds completely, you rise to your shaky legs, leaning against the wall to prevent yourself from falling over.
                        [/p]
                        [p]
                            Luckily, some of the longer lasting aftereffects of the transformation-mix are starting to fade.
                            While, at first, your legs are exceedingly unsteady, you are able to walk anew, without any kind of support, in just a few minutes.
                            Your loins still aching, you [i]do[/i] end up walking with a slight limp, however.
                            And your limbs, in general, feel just a little less [i]powerful[/i] than before.
                            Having recovered most of your motor skills, you begin trying to break out of the enclosure you are trapped in.
                        [/p]
                        [p]
                            Your first thought is to [b]dig[/b] your way out, but the ground the barn was built on feels pretty solid.
                            Too hard to dig through.
                            Besides, it might take too long.
                            Then, you recall a plan you had when you first entered this place.
                            You wanted to crawl ontop of one of the walls, to see what was inside of the enclosures.
                            And that's exactly how you're going to get out of here.
                        [/p]
                        [p]
                            With a small jump, you skillfully manage to grab onto the top of the wooden wall.
                            While your arms are still feeling rather weak, you still manage to lift your slim body upwards.
                            Swinging a single leg over the enclosure, you almost lose your balance and fall down to the ground,
                            yet you manage to keep yourself stable due to years of experience in thievery and burglary.
                            Swinging your second leg over the wall, you hop down to the ground,
                            your weakened legs only barely refraining from buckling, a second near-faceplant narrowly avoided.
                            You hope this enfeebling effect isn't permanent.
                        [/p]
                        [p]
                            Looking around, you notice three ways to leave the barn.
                            A door leading to the house, which you're reasonably certain was the one Cassidy locked on her way out,
                            the front door, through which you entered this horrible place,
                            and the back door, the one you are closest to.
                            ${gear ? "You try, but fail to find your stripped gear. Bitch must have taken it indoors." : ""}
                        [/p]
                        [p]
                            With a loud sigh, you decide to leave through the back door.
                            ${gear ? "You'd rather be naked and free than clothed and at risk of being imprisoned as a breeding slave [b]for life[/b]." : ""}
                            ${gear ? "Besides, if" : "If"} Cassidy catches you out of your pen,
                            she'd probably send you straight to the slaughterhouse instead of trying to [i]tame[/i] you.
                            Opening the large, rickety wooden door, you slip outside, your naked body assaulted by a cold winter breeze.
                            Shivering, you sneak out of the wicked bitch's back yard unnoticed.
                        [/p]
                        [p]
                            Still, you'd rather not take any chances.
                            Travelling via back roads, skipping through fields and traversing small patches of woodland, you make your way towards Varanar.
                            Close to the evening, you arrive at the eastern road, just a few miles away from the city limits.
                            Your adventure at the barn has left you scarred for life,
                            but at least you're left with a brighter future than becoming a sentient [b]cow[/b].
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.continued();
        var choice = `<div class="choicecontainer">`;
        choice += `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        choice += `</div>`;
        return choice;
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "barnEscape";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.tiedUp.get() !== BarnTiedChoice.ESCAPE) {
            return "";
        }

        global.ui.applyTheme("hamlet_day");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.barnEscape.change();
        part += buildChoice();
        part += `<span class="todo">There is no content beyond this point.</span>`;
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.tiedUp.get() !== BarnTiedChoice.ESCAPE) {
            return;
        }

        //toEager.registerListeners();

        if (ctrl.continued()) {
            return;
        }

        //registerContinueListener();
    };
}
